#!/usr/bin/perl
# cronreset.pl	2003/07/10
#
# This script has to be executed via cron or similar daemons.
# Its purpose is to send alive messages to the Telejet Keyboard
# Simulator which will cause it to reset its internal timer.
# If a timeout occurs a hardreset will be initiated.
#
# Example crontab entry:
# */4 * * * *		/path/to/cronreset.pl

#####################
### CONFIGURATION ###
#####################

$TKSADDRESS = "00000A";			# TKS address 
$RESETTERFIFO = '/tmp/.resetter-fifo';	# absolute path to resetter fifo (see resetter-worker.pl)

### END CONFIGURATION ###


$hexaddress = hex($TKSADDRESS);
$command = sprintf("#TO_KBD%c%c%c%cC", $hexaddress >> 16, ($hexaddress >> 8) & 0xff, $hexaddress & 0xff, 4);
$crc = &crc($command);
$command = sprintf("%s%c%c\n", $command, ($crc >> 8), ($crc & 0x0ff));

open(FIFO, ">> $RESETTERFIFO") or die "FATAL: Can't open resetter fifo";
print FIFO $command;
close(FIFO);

exit 0;

sub crc {
	my $crc16_word, $r1_word, $data, @chars;
	my @crc_table = (
		0x0000,
		0xcc01,
		0xd801,
		0x1400,
		0xf001,
		0x3c00,
		0x2800,
		0xe401,
		0xa001,
		0x6c00,
		0x7800,
		0xb401,
		0x5000,
		0x9c01,
		0x8801,
		0x4400
	);

	@chars = split(//, $_[0]);
	foreach $char (@chars) {
		$data = ord($char);
		$r1_word = $crc_table[$crc16_word & 0x0f];
		$crc16_word = ($crc16_word >> 4) & 0x0fff;
		$crc16_word = $crc16_word ^ $r1_word ^ $crc_table[$data & 0x0f];
		$r1_word = $crc_table[$crc16_word & 0x0f];
		$crc16_word = ($crc16_word >> 4) & 0x0fff;
		$crc16_word = $crc16_word ^ $r1_word ^ $crc_table[$data >> 4];
	}

	return $crc16_word;
}
